import { FileStore } from '../../components/file/file-store';
import { Group } from '../../components/group/group';
import { GroupItemProps } from '../../components/group/group.props';
import { JobHandler } from '../../libs/queue-jobs/job-handler.interface';
import { JobExecute } from './job-executor';
import { JobProps } from './job.props';
export declare abstract class Job extends Group<JobProps, GroupItemProps> implements JobHandler {
    queue?: {
        concurrent?: number;
        file?: string;
        password?: string;
        storage?: FileStore;
    };
    private jobsManager?;
    constructor({ queue, ...props }: JobProps);
    onJobInit(jobs: JobExecute[]): JobExecute[];
    exec(input?: Record<string, any>): Promise<never[]>;
    protected addJobData(jobData: any): Promise<void>;
    abstract execJob(_input?: Record<string, any>): any;
    stop(): Promise<void>;
    dispose(): Promise<void>;
}
