"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Echo = void 0;
const chalk_1 = __importDefault(require("chalk"));
const util_1 = require("util");
const element_shadow_1 = require("../element-shadow");
class Echo extends element_shadow_1.ElementShadow {
    content;
    style;
    constructor(props) {
        super();
        if (typeof props !== 'object') {
            props = {
                content: props
            };
        }
        Object.assign(this, props);
    }
    async exec() {
        this.logger.info(this.format());
        return this.content;
    }
    format() {
        const style = this.style ? chalk_1.default[this.style] : (msg) => msg;
        if (typeof this.content === 'object') {
            return (0, util_1.format)(`${style('%j')}`, this.content);
        }
        return style(this.content?.toString());
    }
}
exports.Echo = Echo;
//# sourceMappingURL=echo.js.map