"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const jest_mock_server_1 = require("jest-mock-server");
const testing_1 = require("../../testing");
const del_1 = require("./del");
const server = new jest_mock_server_1.MockServer();
let request;
beforeAll(async () => await server.start());
afterAll(async () => await server.stop());
beforeEach(async () => {
    await testing_1.Testing.reset();
    server.reset();
});
afterEach(async () => {
    await request.dispose();
});
test('should send request ok', async () => {
    server.delete('/')
        .mockImplementationOnce((ctx) => {
        ctx.status = 201;
        ctx.message = 'OK MEN';
        expect(ctx.query.time).toBeDefined();
        expect(ctx.query.rd).toBeDefined();
    });
    request = await testing_1.Testing.newElement(del_1.Del, {
        url: server.getURL().toString() + '?time=' + Date.now().toString(),
        query: {
            rd: Math.random().toString()
        },
        vars: {
            status: '${this.response.status}',
            statusText: '${this.response.statusText}'
        }
    });
    await request.exec();
    expect(testing_1.Testing.vars.status).toBe(201);
    expect(testing_1.Testing.vars.statusText).toBe('OK MEN');
});
//# sourceMappingURL=del.spec.js.map