import { InputSuggestInterface } from './input-suggest.interface';
import { InputAbstract } from './input.abstract';
export interface SuggestType {
    STARTSWITH_AND_ALLOW_NEW: Function;
    STARTSWITH: Function;
    INCLUDE_AND_ALLOW_NEW: Function;
    INCLUDE: Function;
}
export declare class InputSuggest extends InputAbstract<InputSuggestInterface> {
    readonly type = "autocomplete";
    choices: Array<{
        title: string;
        value: any;
    }>;
    limit?: number;
    style?: string;
    suggestType?: keyof SuggestType;
    get suggest(): Function;
    constructor({ choices, limit, style, suggestType, ...props }: Partial<InputSuggestInterface>);
    exec(): Promise<boolean | null | undefined>;
}
