"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const testing_1 = require("../../testing");
const install_1 = require("./install");
let install;
beforeEach(async () => {
    await testing_1.Testing.reset();
});
afterEach(async () => {
    await install.dispose();
});
test('should install librarries as an array input', async () => {
    const packsInstall = ['a', 'b', 'c'];
    install = await testing_1.Testing.newElement(install_1.Install, packsInstall);
    install.action = jest.fn().mockImplementationOnce((...packs) => {
        expect(packs).toEqual(packsInstall);
    });
    await install.exec();
});
test('should install librarries as an full object', async () => {
    const packsInstall = ['a', 'b', 'c'];
    install = await testing_1.Testing.newElement(install_1.Install, {
        title: 'Install lack packages',
        packages: packsInstall
    });
    install.action = jest.fn().mockImplementationOnce((...packs) => {
        expect(packs).toEqual(packsInstall);
    });
    await install.exec();
});
//# sourceMappingURL=install.spec.js.map