"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RootScene = void 0;
const scene_1 = require("./../components/scene/scene");
const events_manager_1 = require("./../managers/events-manager");
const tags_manager_1 = require("./../managers/tags-manager");
const templates_manager_1 = require("./../managers/templates-manager");
const utility_function_manager_1 = require("./../managers/utility-function-manager");
class RootScene extends scene_1.Scene {
    logger;
    tagsManager = new tags_manager_1.TagsManager(this);
    templatesManager = new templates_manager_1.TemplatesManager();
    globalUtils = new utility_function_manager_1.UtilityFunctionManager();
    globalVars = {};
    runDir = process.cwd();
    rootDir = '';
    constructor(props, logger) {
        super(props);
        this.logger = logger;
        this.$$ignoreEvalProps.push('globalUtils', 'tagsManager', 'globalVars', 'templatesManager', 'rootDir');
        this.log = this.logger.levelName;
        this.isRoot = true;
        this.scene = this.rootScene = this;
    }
    async exec() {
        events_manager_1.GlobalEvent.emit('scene/exec:before');
        try {
            const rs = await super.exec();
            return rs;
        }
        finally {
            events_manager_1.GlobalEvent.emit('scene/exec:end');
        }
    }
    async dispose() {
        events_manager_1.GlobalEvent.emit('scene/dispose:before');
        try {
            await super.dispose();
        }
        finally {
            events_manager_1.GlobalEvent.emit('scene/dispose:end');
        }
    }
}
exports.RootScene = RootScene;
//# sourceMappingURL=root-scene.js.map