"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.loadESModule = exports.nodeModulesDir = exports.libDir = exports.libName = void 0;
const module_1 = require("module");
const path_1 = require("path");
const package_json_1 = require("../../package.json");
exports.libName = `${package_json_1.name}/`;
exports.libDir = (0, path_1.join)(__dirname, '../..');
exports.nodeModulesDir = (0, path_1.join)(__dirname, '../node_modules');
async function loadESModule(name) {
    return new Function(`return import('${name}')`).call(undefined);
}
exports.loadESModule = loadESModule;
function registerModulePlatform() {
    const _require = module_1.Module.prototype.require;
    module_1.Module.prototype.require = function (basePath) {
        if (basePath.startsWith(exports.libName)) {
            basePath = exports.libDir + basePath.substring(package_json_1.name.length);
        }
        return _require.call(this, basePath);
    };
}
registerModulePlatform();
//# sourceMappingURL=modules-manager.js.map