"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TagsManager = exports.ClassInFileCharacter = void 0;
const path_1 = require("path");
const modules_manager_1 = require("./modules-manager");
const packages_manager_1 = require("./packages-manager");
exports.ClassInFileCharacter = "'";
class TagsManager {
    scene;
    modules = {};
    tags = {};
    constructor(scene) {
        this.scene = scene;
    }
    register(name, pathOfModule) {
        this.modules[name] = this.scene.getPath(pathOfModule);
    }
    setTag(name, obj) {
        this.tags[name] = obj;
    }
    async getTag(name) {
        var _a;
        const path = this.modules[name];
        let isExit;
        try {
            if (!path)
                throw new Error(`Could not found tag module "${name}"`);
            isExit = true;
            const Clazz = await (_a = path, Promise.resolve().then(() => __importStar(require(_a))));
            return Clazz;
        }
        catch (err) {
            const tag = this.tags[name];
            if (!tag) {
                err.$$exit = isExit;
                throw err;
            }
            return tag;
        }
    }
    reset() {
        this.modules = {};
    }
    async loadElementClass(name, scene) {
        var _a, _b, _c;
        let ElementModule;
        const [path, className = 'default'] = name.split(exports.ClassInFileCharacter);
        let packagesManager;
        do {
            try {
                ElementModule = await (_a = `../components/${path}`, Promise.resolve().then(() => __importStar(require(_a))));
            }
            catch (err1) {
                try {
                    ElementModule = await this.getTag(path);
                }
                catch (err2) {
                    if (err2.$$exit)
                        throw err2;
                    try {
                        try {
                            ElementModule = await (_b = path, Promise.resolve().then(() => __importStar(require(_b))));
                        }
                        catch {
                            ElementModule = await (_c = (0, path_1.join)(modules_manager_1.nodeModulesDir, path), Promise.resolve().then(() => __importStar(require(_c))));
                        }
                    }
                    catch (err3) {
                        if (packagesManager) {
                            scene.logger.error(err1?.message);
                            scene.logger.error(err2?.message);
                            scene.logger.error(err3?.message);
                            throw new Error(`Could not found class "${className}" in "${path}"`);
                        }
                        scene.logger.warn(err1?.message);
                        scene.logger.warn(err2?.message);
                        scene.logger.warn(err3?.message);
                        packagesManager = new packages_manager_1.PackagesManager(scene);
                        await packagesManager.install(path);
                    }
                }
            }
        } while (!ElementModule);
        let ElementClazz = ElementModule[className];
        if (ElementClazz && !ElementClazz.prototype) {
            if (typeof ElementClazz === 'function') {
                try {
                    ElementClazz = await ElementClazz();
                }
                catch (err) {
                    err.$$exit = true;
                    throw err;
                }
            }
            else {
                const { constructor, ...objProps } = ElementClazz;
                ElementClazz = class {
                    constructor(props) {
                        constructor?.call(this, props);
                    }
                };
                Object.assign(ElementClazz.prototype, objProps);
            }
        }
        if (!ElementClazz?.prototype)
            throw new Error(`Could not found the tag "${path}.${className}"`);
        return ElementClazz;
    }
}
exports.TagsManager = TagsManager;
//# sourceMappingURL=tags-manager.js.map